%global texinfo_dir %{_datadir}/texlive/texmf-dist/tex/texinfo
# perl scripts in texinfo are not installed in default perl library dirs
# no provide and requires from them.
%global __provides_exclude ^perl\\(.*Texinfo.*\\)$
%global __requires_exclude ^perl\\(.*Texinfo.*\\)$

%bcond_without tex

Summary: Tools needed to create Texinfo format documentation files
Name: texinfo
Version: 7.0.3
Release: 6%{?dist}
License: GPLv3+
Url: http://www.gnu.org/software/texinfo/
Source0: ftp://ftp.gnu.org/gnu/texinfo/texinfo-%{version}.tar.xz


Patch3000: texinfo-7.0.2-undef-val-array-ref.patch 

BuildRequires: make gcc
BuildRequires: perl-generators help2man ncurses-devel
BuildRequires: perl(Locale::Messages) perl(Unicode::EastAsianWidth) 
BuildRequires: perl(Storable) perl(Unicode::Normalize) perl(File::Copy) 
BuildRequires: perl(Text::Unidecode)  perl(Data::Dumper)

%description
Texinfo uses a single source file to produce output in a number of formats, 
both online and printed (DVI, HTML, Info, PDF, XML, etc.). This means that 
instead of writing different documents for online information and another for 
a printed manual, you need write only one document.


%package -n info
Summary: A stand-alone TTY-based reader for GNU texinfo documentation
Provides: /sbin/install-info
Requires: less grep

%description -n info
This package provides a standalone TTY-based
browser program for viewing texinfo files. The 
GNU project uses the texinfo file format for much of its
documentation.

%if %{with tex}
%package tex
Summary: Utility for formatting Texinfo documentation files using TeX
Requires: texinfo = %{version}-%{release}
Requires: tex(tex) tex(epsf.tex)
Requires(post): %{_bindir}/texconfig-sys
Requires(postun): %{_bindir}/texconfig-sys
Provides: tex-texinfo
Provides: texlive-texinfo

%description tex
The texinfo-tex package provides tools to format Texinfo documents
for printing using TeX. Texinfo is a documentation system that can 
produce both online information and printed output from a single 
source file. The GNU Project uses the Texinfo file format for most 
of its documentation.
%endif

%prep
%autosetup -p1

%build
%configure --with-external-Text-Unidecode \
           --with-external-libintl-perl \
           --with-external-Unicode-EastAsianWidth \
           --disable-perl-xs
%make_build

%install
mkdir -p %{buildroot}/sbin

%make_install

mkdir -p %{buildroot}%{texinfo_dir}
install -p -m644 doc/texinfo.tex doc/txi-??.tex %{buildroot}%{texinfo_dir}

mkdir -p %{buildroot}%{_sbindir}
mv %{buildroot}%{_bindir}/install-info %{buildroot}%{_sbindir}

%if %{without tex}
rm -f %{buildroot}%{_bindir}/texindex
rm -f %{buildroot}%{_bindir}/texi2dvi
rm -f %{buildroot}%{_bindir}/texi2pdf
rm -f %{buildroot}%{_bindir}/pdftexi2dvi
rm -rf %{buildroot}%{texinfo_dir}/
rm -f %{buildroot}%{_mandir}/man1/texindex.1*
rm -f %{buildroot}%{_mandir}/man1/texi2dvi.1*
rm -f %{buildroot}%{_mandir}/man1/texi2pdf.1*
rm -f %{buildroot}%{_mandir}/man1/pdftexi2dvi.1*
%endif

%find_lang %{name}
%find_lang %{name}_document

%check
export ALL_TESTS=yes
%make_build check

%if %{with tex}
%post tex
%{_bindir}/texconfig-sys rehash 2> /dev/null || :

%postun tex
%{_bindir}/texconfig-sys rehash 2> /dev/null || :
%endif

%transfiletriggerin -n info -- %{_infodir}/*.info* %{_infodir}/texinfo.*
if [ $1 -eq 1 -o $2 -eq 1 ]; then
    while [ -n "$3" ]; do
	if [ -f "$3" ]; then
	    LESSOPEN="|/usr/bin/lesspipe.sh %s" LESS_ADVANCED_PREPROCESSOR=1 less "$3" | grep -q -e INFO-DIR-SECTION && %{_bindir}/install-info "$3" --dir=%{_infodir}/dir
	fi
	shift
    done
fi

%transfiletriggerun -n info -- %{_infodir}/*.info* %{_infodir}/texinfo.*
if [ $2 -eq 0 ]; then
    while [ -n "$3" ]; do
	if [ -f "$3" ]; then
	    LESSOPEN="|/usr/bin/lesspipe.sh %s" LESS_ADVANCED_PREPROCESSOR=1 less "$3" | grep -q -e INFO-DIR-SECTION && %{_bindir}/install-info "$3" --dir=%{_infodir}/dir --remove
	fi
	shift
    done
fi

%files -f %{name}.lang -f %{name}_document.lang
%license COPYING
%doc AUTHORS ChangeLog NEWS README TODO
%{_bindir}/makeinfo
%{_bindir}/texi2any
%{_bindir}/pod2texi
%{_datadir}/texinfo
%{_infodir}/texinfo*
%{_infodir}/texi2any_api.info*
%{_infodir}/texi2any_internals.info*
%{_mandir}/man1/makeinfo.1*
%{_mandir}/man5/texinfo.5*
%{_mandir}/man1/texi2any.1*
%{_mandir}/man1/pod2texi.1*

%files -n info
%license COPYING
%{_bindir}/info
%{_sbindir}/install-info
%{_infodir}/info-stnd.info*
%{_mandir}/man1/info.1*
%{_mandir}/man1/install-info.1*
%{_mandir}/man5/info.5*
%ghost %{_infodir}/dir
%ghost %attr(644, root, root) %{_infodir}/dir.old

%if %{with tex}
%files tex
%{_bindir}/texindex
%{_bindir}/texi2dvi
%{_bindir}/texi2pdf
%{_bindir}/pdftexi2dvi
%{texinfo_dir}/
%{_mandir}/man1/texindex.1*
%{_mandir}/man1/texi2dvi.1*
%{_mandir}/man1/texi2pdf.1*
%{_mandir}/man1/pdftexi2dvi.1*
%endif

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.3-6
- Rebuilt for loongarch release

* Fri Jun 07 2024 Doris Chao <doriscchao@tencent.com> - 7.0.3-4
- [Type] bugfix
- [DESC] Change the way info files information is updated, no longer using
- the fix-info-dir script,since bash no loonger provies the /usr/share/info/dir

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.3-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Jul 28 2023 kianli <kianli@tencent.com> - 7.0.3-2
- Fix incorrect file data of fix-info-dir

* Fri Jul 28 2023 kianli <kianli@tencent.com> - 7.0.3-1
- Upgrade to 7.0.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.8-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.8-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Nov 02 2022 Yi Lin <nilusyi@tencent.com> - 6.8-2
- add bcond on texinfo-tex, default is delete texinfo-tex.

* Tue Jul 26 2022 Yi Lin <nilusyi@tencent.com> - 6.8-1
- package init.
